#TEMPLATE (GWBExportToCSV, 'Export to CSV From Browse and Report'),FAMILY('ABC')
#! 
#EXTENSION(GWBCSVExport,'CSV Export Global Extension'),DESCRIPTION('GWBCSVExport Globals'),APPLICATION
#!
#SHEET
  #TAB('Registro')
    #IMAGE('GWBCopy.WMF'),AT(,,180,60)
    #BOXED ('Copyright Notice')
      #DISPLAY()
      #DISPLAY('Este programa est registrado y')
      #DISPLAY('se prohibe el uso para fines comerciales')
      #DISPLAY('en todo el mundo.')
      #DISPLAY()
      #DISPLAY('No debe ser copiado o corregido por ')
      #DISPLAY('terceros sin autorizacin.')
      #DISPLAY()
      #DISPLAY()
      #DISPLAY()
      #DISPLAY()
      #DISPLAY('Registrado en 2002')
      #DISPLAY()
    #ENDBOXED
  #DISPLAY ()
  #BOXED   ('')
    #DISPLAY ()
    #DISPLAY ('Si el nombre de archivo queda en blanco')
    #DISPLAY ('el archivo no ser grabado')
    #DISPLAY ('Con REP9=1 imprime el rengln ')
    #DISPLAY ('Con Rep9=0 no lo imprime ')
  #ENDBOXED
  #ENDTAB
#ENDSHEET
#!--------------------------------------------------
#AT(%CustomGlobalDeclarations)
  #FIX(%Driver,'ASCII')
  #ADD(%UsedDriverDLLs,%DriverDLL)
  #PROJECT(%DriverLIB)
#ENDAT
#!--------------------------------------------------
#AT(%GlobalData)
GWBCSVFileName  CSTRING(100)
REP9            BYTE
GWBCSVFile  FILE,DRIVER('ASCII'),NAME(GWBCSVFileName),CREATE,PRE(GWBCSV)
Record        RECORD
Line            STRING(1000)
              END
            END
#ENDAT
#!--------------------------------------------------
#! --------------------------------------------------------------------------
#! Browse Fields
#! --------------------------------------------------------------------------
#CONTROL(GWBCSVBrowseExport,'Export Browse Values'),DESCRIPTION('Export to CSV'),LAST,REQ(BrowseBox(ABC))
  CONTROLS
    BUTTON('Export to CSV'),AT(,,55,20),USE(?ExportToCSV),LEFT
  END
#!--------------------------------------------------
#ATSTART
  #DECLARE(%GWBExportControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
     #SET(%GWBExportControl,%Control)
  #ENDFOR
#ENDAT
#!--------------------------------------------------
#PREPARE
  #FIND(%ControlInstance,%ActiveTemplateParentInstance,%Control)
  #DECLARE(%GWBQueueField),UNIQUE
  #!First add browse display fields to queue
  #FOR(%ControlField)
    #ADD(%GWBQueueField,%ControlField)
  #ENDFOR
  #!2nd append hot field to queue
  #FOR(%HotFields)
    #ADD(%GWBQueueField,%HotField)
  #ENDFOR
  #SELECT(%GWBSortedFields,1)
  #IF(NOT %GWBSortedFields)
    #FOR(%GWBQueueField),WHERE(~INLIST(%GWBQueueField,%GWBSortedFields))
      #ADD(%GWBSortedFields,%GWBQueueField)
    #ENDFOR
  #ENDIF
  #IF(NOT %GWBCSVFileName)
    #SET(%GWBCSVFileName,%Primary & 'C:\REPORTE.CSV')
  #ENDIF
#ENDPREPARE
#!--------------------------------------------------
#BOXED('GWB CSV Export')
  #DISPLAY()
  #BUTTON('CSV Fields')
  #PROMPT('Specify Fields and Order in File',FROM(%GWBQueueField)),%GWBSortedFields,MULTI('Sort Fields'),INLINE,REQ
  #ENDBUTTON
  #DISPLAY()
  #PROMPT ('Name of CSV File to Create:',@S40),%GWBCSVFileName,AT(100)
  #DISPLAY()
  #DISPLAY('No olvide incluir eltemplate global!')
#ENDBOXED
#!
#!--------------------------------------------------
#AT(%DataSection),PRIORITY(1000)
GWBExportInProgress  BYTE
GWBExportFinished    BYTE
GWBProgressCounter   LONG
GWBExportCSVWindow WINDOW('Exportando a Archivo Ascii'),AT(,,371,58),FONT('MS Sans Serif',8,,FONT:regular), |
         CENTER,TIMER(1),SYSTEM,GRAY,DOUBLE,MODAL
       STRING(''),AT(68,0,284,10),USE(?GWBProgressString)
       PROGRESS,USE(?ProgressBar),AT(95,13,257,10),RANGE(0,100)
       PROMPT('Nombre de Archivo csv:'),AT(11,26),USE(?CsvFileNamePrompt)
       ENTRY(@s100),AT(95,26,257,10),USE(GWBCSVFileName)
       BUTTON('Exporta'),AT(202,40,55,15),USE(?GWBExportCSVButton)
       BUTTON('Regresa'),AT(297,40,55,15),USE(?GWBExitButton)
     END

#ENDAT
#!--------------------------------------------------
#AT(%ProcedureRoutines),PRIORITY(4000)
#FIND(%ControlInstance,%ActiveTemplateParentInstance,%Control)
#!
#CALL(%GWBConstructFields)
#!
GWBStartExportToCSV%ActiveTemplateInstance ROUTINE
  !GWBCSVFileName = PATH() & '\%GWBCSVFileName'
  OPEN(GWBExportCSVWindow)
  ACCEPT
    CASE EVENT()
    OF EVENT:Timer
      IF GWBExportInProgress
        IF GWBExportFinished
          BREAK
        END
        DO GWBAddToExportFile
      END
    OF EVENT:Accepted
      CASE FIELD()
      OF ?GWBExitButton
        BREAK
      OF ?GWBExportCSVButton
        DO GWBExportCSV%ActiveTemplateInstance
      END
    END
  END
  ?ProgressBar{Prop:Progress} = 0
  GWBProgressCounter = 0
  GWBExportInProgress = False
  GWBExportFinished = False
  CLOSE(GWBCSVFile)
  CLOSE(GWBExportCSVWindow)
  EXIT
#!

GWBExportCSV%ActiveTemplateInstance  ROUTINE
  IF GWBExportInProgress
    EXIT
  END
  GWBExportInProgress = True
  GWBExportFinished = False
  GWBProgressCounter = 0
  CLOSE(GWBCSVFile)
  CREATE(GWBCSVFile)
  IF ERRORCODE() 
    STOP('Error Creating ' & GWBCSVFileName & ERROR())
    EXIT
  END  
  OPEN(GWBCSVFile)
  IF ERRORCODE() 
    STOP('Error Opening ' & GWBCSVFileName & ERROR())
    EXIT
  END  
  ! add header for file
  GWBCSV:Line = %GWBHeader
  !ADD(GWBCSVFile)
  IF ERRORCODE()
    STOP('Error Adding Header to ' & GWBCSVFileName & ERROR())
    EXIT
  END
  SET(%ListView)
  GWBExportCSVWindow{Prop:Timer} = 1
  EXIT

GWBAddToExportFile  ROUTINE
  GWBExportCSVWindow{Prop:Timer} = 0
  LOOP 100 TIMES
    NEXT(%ListView)
    IF ERRORCODE()
      GWBExportFinished = True
      BREAK
    END
#IF(%GWBHotData)
  #FIND(%ControlInstance,%ActiveTemplateParentInstance,%Control)
    BRW%ActiveTemplateParentInstance.SetQueueRecord
#ENDIF
    GWBCSV:Line = %GWBData

    DISPLAY()
    IF REP9=1
      ADD(GWBCSVFile)
      IF ERRORCODE()
        STOP('Error Adding Record to ' & GWBCSVFileName & ERROR())
        EXIT
      END
    END  
  END !loop
  GWBProgressCounter += 1
  ?GWBProgressString{Prop:Text} = GWBProgressCounter * 100 & ' Records Exported'
  ?ProgressBar{Prop:Progress} = GWBProgressCounter % 100
  DISPLAY()
  GWBExportCSVWindow{Prop:Timer} = 1
  EXIT
#ENDAT
#!--------------------------------------------------
#AT(%ControlEventHandling,%GWBExportControl,'Accepted')
Do GWBStartExportToCSV%ActiveTemplateInstance
#ENDAT
#!--------------------------------------------------

#! --------------------------------------------------------------------------
#! --------------------------------------------------------------------------
#! Report Fields
#! --------------------------------------------------------------------------
#! --------------------------------------------------------------------------
#CONTROL(GWBCSVReportExport,'Export Report Values'),DESCRIPTION('Exporta a CSV'),LAST,REQ(PauseButton(ABC))
#!
  CONTROLS
       PROMPT('Nombre de Archivo:'),AT(,),USE(?CsvFileNamePrompt)
       ENTRY(@s100),AT(,,80,10),USE(GWBCSVFileName),REQ
  END
#!--------------------------------------------------
#ATSTART
  #DECLARE(%GWBExportControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
     #SET(%GWBExportControl,%Control)
  #ENDFOR
#ENDAT
#!--------------------------------------------------
#PREPARE
  #DECLARE(%GWBQueueField),UNIQUE
  #IF(%PrimaryKey)
    #FIX(%File,%Primary)
    #FIX(%Key,%PrimaryKey)
    #FOR(%KeyField)
      #ADD(%GWBQueueField,%KeyField)
    #ENDFOR
  #ENDIF
  #FOR (%HotFields)
    #ADD(%GWBQueueField,%HotField)
  #ENDFOR
  #FOR (%Formula),WHERE(ITEMS(%FormulaField))
    #FOR (%FormulaField)
      #ADD(%GWBQueueField,%FormulaField)
    #ENDFOR
  #ENDFOR
  #FOR (%ReportControl),WHERE(%ReportControlUse)
    #ADD(%GWBQueueField,%ReportControlUse)
  #ENDFOR
  #SELECT(%GWBSortedFields,1)
  #IF(NOT %GWBSortedFields)
    #FOR(%GWBQueueField),WHERE(~INLIST(%GWBQueueField,%GWBSortedFields))
      #ADD(%GWBSortedFields,%GWBQueueField)
    #ENDFOR
  #ENDIF
  #IF(NOT %GWBCSVFileName)
    !#SET(%GWBCSVFileName,%Primary & 'c:\Reporte.csv')
    !#SET(%GWBCSVFileName,'c:\Reporte.csv')
    #SET(%GWBCSVFileName,'')
  #ENDIF
#ENDPREPARE
#!--------------------------------------------------
#BOXED('GWB CSV Export')
  #DISPLAY()
  #BUTTON('CSV Fields')
  #PROMPT('Specify Fields and Order in File',FROM(%GWBQueueField)),%GWBSortedFields,MULTI('Sort Fields'),INLINE,REQ
  #ENDBUTTON
  #DISPLAY()
  #PROMPT ('Nombre de Archivo:',@S40),%GWBCSVFileName,AT(100)
  #DISPLAY()
  #DISPLAY('No olvides el Template Global!')
#ENDBOXED
#!
#!--------------------------------------------------
#AT(%DataSection),PRIORITY(1000)
  #CALL(%GWBGetKeyFields)
  #FOR(%GWBKeyFields)
    #FIND(%Field,%GWBKeyFields)
    #IF(%Field)
GWBKey:%FieldStruct
    #ENDIF
  #ENDFOR
#ENDAT
#!--------------------------------------------------
#AT(%ProcedureRoutines),PRIORITY(4000)
#FIND(%ControlInstance,%ActiveTemplateParentInstance,%Control)
#!
#CALL(%GWBConstructFields)
#!
GWBCreateCSV%ActiveTemplateInstance  ROUTINE

  IF LEN(GWBCSVFileName)>2
    
    X#=INSTRING('.',GWBCSVFileName,1,1)

    IF X#>0
      GWBCSVFileName=SUB(GWBCSVFileName,1,X#-1)
    .
    GWBCSVFileName=CLIP(GWBCSVFileName)&'.CSV'

    CLOSE(GWBCSVFile)
    CREATE(GWBCSVFile)
    IF ERRORCODE()
      STOP('Error Creating ' & GWBCSVFileName & ERROR())
      EXIT
    END
    OPEN(GWBCSVFile)
    IF ERRORCODE()
      STOP('Error Opening ' & GWBCSVFileName & ERROR())
      EXIT
    END
    ! add header for file
    GWBCSV:Line = %GWBHeader
    #EMBED(%ModifyTitle,'GWBCSV:Line = Titulo')
    ADD(GWBCSVFile)
  
    IF ERRORCODE()
      STOP('Error Adding Header to ' & GWBCSVFileName & ERROR())
    END
  END
  EXIT

GWBExportCSV%ActiveTemplateInstance  ROUTINE
  GWBCSV:Line = %GWBData

  DISPLAY()
  IF REP9=1 AND LEN(GWBCSVFileName)>2
    ADD(GWBCSVFile)
    IF ERRORCODE()
      STOP('Error Adding Record to ' & GWBCSVFileName & ERROR())
    END
  END
  EXIT

#ENDAT
#!--------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(7900),DESCRIPTION('Set Default File Name')
  GWBCSVFileName = PATH() & '\%GWBCSVFileName'
#ENDAT
#!--------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'OpenReport','(),BYTE'),PRIORITY(6500)
IF ReturnValue <> Level:Fatal
  DO GWBCreateCSV%ActiveTemplateInstance
END
#ENDAT
#!--------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'AskPreview'),PRIORITY(50)
  CLOSE(GWBCSVFile)
#ENDAT
#!--------------------------------------------------
#AT(%ProcessManagerMethodCodeSection,'TakeRecord','(),BYTE'),PRIORITY(5500),DESCRIPTION('GWBCSVExportReport Call GWBExportCSV' & %ActiveTemplateInstance)
  #DECLARE(%ValueConstruct)
  #FOR(%GWBKeyFields)
    #FIND(%Field,%GWBKeyFields)
    #IF(%Field)
      #IF(~%ValueConstruct)
        #SET(%ValueConstruct,'IF GWBKey:' & %FieldID & ' <<> ' & %Field)
      #ELSE
        #SET(%ValueConstruct,%ValueConstruct & ' OR GWBKey:' & %FieldID & ' <<> ' & %Field)
      #ENDIF
    #ENDIF
  #ENDFOR
  %ValueConstruct
  #FOR(%GWBKeyFields)
    #FIND(%Field,%GWBKeyFields)
    #IF(%Field)
    GWBKey:%FieldID = %Field
    #ENDIF
  #ENDFOR
    DO GWBExportCSV%ActiveTemplateInstance
  END
#ENDAT
#!
#!-------------------------------------------------------------------------
#GROUP(%GWBConstructFields)
#!
#DECLARE(%GWBHeader)
#DECLARE(%GWBData)
#DECLARE(%GWBTempFieldName)
#DECLARE(%GWBHotData)
#SET(%GWBHotData,0)
#!
#SELECT(%GWBSortedFields,1)
#IF(%GWBSortedFields)
  #FOR(%GWBSortedFields)
    #INSERT(%GWBConcatenate,%GWBSortedFields)
  #ENDFOR
#ELSE
  #ERROR(%Procedure & ' - GWB CSV Export Template - No Fields have been selected for Export')
#ENDIF
#SET(%GWBHeader,'<39>' & %GWBHeader & '<39>')
#!
#!-------------------------------------------------------------------------
#GROUP(%GWBConcatenate,%GWBTempField)
#FIND(%Field,%GWBTempField)
#IF(~%Field)
  #SET(%GWBHotData,1)
#ENDIF
#IF(NOT %GWBHeader)
  #SET(%GWBHeader,' ' &  %GWBTempField & ' ')
  #IF(SUB(UPPER(%FieldDisplayPicture),1,2) = '@N')
    #SET(%GWBData,%GWBTempField)
  #ELSIF(NOT %FieldDisplayPicture)
    !#SET(%GWBData,'<39> <39> & ' & %GWBTempField & ' & <39> <39>')
    #SET(%GWBData,%GWBTempField)
  #ELSE
    #SET(%GWBData,'<39> <39> & FORMAT(' & %GWBTempField & ',' & %FieldDisplayPicture & ') & <39> <39>')
  #ENDIF
#ELSE
  #SET(%GWBHeader,%GWBHeader & ';' &  %GWBTempField & '')
  #IF(SUB(UPPER(%FieldDisplayPicture),1,2) = '@N')
    #SET(%GWBData,%GWBData & ' & <39>;<39> & ' & %GWBTempField)
  #ELSIF(NOT %FieldDisplayPicture)
    #SET(%GWBData,%GWBData & ' & <39>; <39> & ' &  %GWBTempField & ' & <39> <39>')
  #ELSE
    #SET(%GWBData,%GWBData & ' & <39>; <39> & FORMAT(' & %GWBTempField & ',' & %FieldDisplayPicture & ') & <39> <39>')
  #ENDIF
#ENDIF
#!-------------------------------------------------------------------------
#GROUP(%GWBGetKeyFields)
#DECLARE(%GWBKeyFields),UNIQUE
#SELECT(%GWBSortedFields,1)
#IF(%GWBSortedFields)
  #FOR(%GWBSortedFields)
    #ADD(%GWBKeyFields,%GWBSortedFields)
  #ENDFOR
#ELSE
  #ERROR(%Procedure & ' - GWB CSV Export Template - No Fields have been selected for Export')
#ENDIF
#!-------------------------------------------------------------------------